from django.contrib import admin
from django.contrib.auth.models import User
from django.contrib.auth.admin import UserAdmin 
from models import *

admin.site.register(Language)
admin.site.register(Tag)
admin.site.register(Comment)
admin.site.register(EntityType)
admin.site.register(WordGrammarType)
admin.site.register(Word)
admin.site.register(Entity)
admin.site.register(Binding)
admin.site.register(Concept)
admin.site.register(ConceptDescription)

admin.site.unregister(User)

class UserDataInline(admin.StackedInline):
    model = UserData

class CustomUserAdmin(UserAdmin):
    inlines = [UserDataInline]

admin.site.register(User, CustomUserAdmin)
