#!/usr/bin/python
# -*- coding: utf8 -*-

# import_old_data.py
# version 0.4

# TODO
# Apskatīties, kādi dati un kādi nav - epasts nav, vārds uzvārds nav utt. Tajos likt None, nevis tukšumus
# Pārbaudīt jau lietotāja esamību - DARĪTS

import time

import sys
sys.path.append('/home/pecisk/Documents/')

import os
os.environ['DJANGO_SETTINGS_MODULE'] = 'wordy.settings'

from django import *

import MySQLdb as mysql
from wordy.database.models import Language, Tag, Entity, EntityType, WordGrammarType, Concept, ConceptDescription, Word, Binding, Comment, UserData
from django.contrib.auth.models import User

db_connection = mysql.connect(user='root',passwd='LeduSUpE',db='termini')
db_connection_cursor = db_connection.cursor()


#db_connection_cursor.execute("SET NAMES utf8;")
#db_connection_cursor.execute("SET CHARACTER SET utf8;")
db_connection_cursor.execute("SET character_set_connection=utf8;")
db_connection_cursor.execute('select * from persons')
persons = db_connection_cursor.fetchall()

# 1. Languages
latvian = Language(localized_name = 'latviešu', english_name = 'Latvian', iso_code = 'lv')
latvian.save()
english = Language(localized_name = 'angļu', english_name = 'English', iso_code = 'en')
english.save()

# 2. Persons
for person in persons:
	# There will be creation of User model and commiting it to the database
	# First, let's check for already existing username, if yes - skip it
	if(len(User.objects.filter(username__exact=person[1])) == 0):
		if(int(person[5]) == 0):
			staff = False
		else:
			staff = True
		usr = User.objects.create_user(person[1], person[2], None)
		usr.password = person[4]
		usr.first_name = person[3]
		usr.is_staff = staff
		usr.save()
		lang = Language.objects.get(id=1)
		#if(person[5] == 'lv'):
		#	lang = Language.objects.get(id=1)
		#elif(person[5] == 'en'):
		#	lang = Language.objects.get(id=2)
		profile = UserData(user=usr,language=lang)
		profile.save()
	else:
		print person[1]
		
# 3. Entities
# 3.1. Entity types
db_connection_cursor.execute('select * from sources_types')
sources_types = db_connection_cursor.fetchall()
for source_type in sources_types:
	entity_type = EntityType(name = source_type[1], description = source_type[2])
	entity_type.save()

# 3.2. Entities
db_connection_cursor.execute('select * from sources')
sources = db_connection_cursor.fetchall()
for source in sources:
	entity = Entity(name = source[2], short_name = source[3], type = EntityType.objects.get(id=int(source[1])))
	entity.save()

# 4. Grammar Types
db_connection_cursor.execute('select * from terms_grammar_types')
grammar_types = db_connection_cursor.fetchall()
for grammar_type in grammar_types:
	word_grammar_type = WordGrammarType(name=grammar_type[1], description=None)
	word_grammar_type.save()

# 5. Tags
needsreview_tag = Tag(name = "needsreview")
needsreview_tag.save()
lonelywolf_tag = Tag(name = "lonelywolf")
lonelywolf_tag.save()

# 6. Concepts and words
# 6.1. Get concepts from english words
# get all english terms from old database
db_connection_cursor.execute('select * from terms where term_language=1')
english_words = db_connection_cursor.fetchall()
print len(english_words)
# prefetch persons
db_connection_cursor.execute('select * from persons')
old_users = db_connection_cursor.fetchall()
# prefetch latvian words
db_connection_cursor.execute('select * from terms where term_language=2')
translations = db_connection_cursor.fetchall()
# prefetch comments
db_connection_cursor.execute('select * from comments')
old_comments = db_connection_cursor.fetchall()
# prefetch bindings
#db_connection_cursor.execute('select * from terms_bindings')
#old_bindings = db_connection_cursor.fetchall()
# for each english word, first add concept, then add english word (if it doesn't exist), then add latvian words (if they doesn't exist) and bind them all with correct binding_entities
# Note: english words doesn't have entities so far. Maybe it would be good to add some, so to mark from what kind of source this word comes
n = 0
for old_word in english_words:
	if(n%1000 == 0): 
		print n
	n = n + 1
	# Create new Concept object
	# old_word[5] is term_description field in old db. If it is not None or it at least have one symbol, add it to concept comments and description in english
	# Note: not all descriptions are given in english (lot of them are in latvian). Should be easy to sort them out though.
	if(old_word[5] != None and old_word[5] != ''):
		new_concept = Concept(comment = old_word[1].strip() + " | " + old_word[5].strip())
	else:
		new_concept = Concept(comment = old_word[1].strip())
	new_concept.save()
	# add ConceptDescription object with proper translation. FIXME - maybe there is a way to detect that description is not in english?
	if(old_word[5] != None and old_word[5] != ''):
		new_concept_description = ConceptDescription(concept = new_concept, title = old_word[1].strip(), description = old_word[5].strip(), language = english)
	else:
		new_concept_description = ConceptDescription(concept = new_concept, title = old_word[1].strip(), description = new_concept.comment, language = english)
	new_concept_description.save()
	# Add "needsreview" tag on Concept object
	new_concept.tags.add(needsreview_tag)
	# Add grammar type to Concept object
	if(old_word[4] == None or old_word[4] == '' or old_word[4] > 4 or old_word[4] == 0):
		new_grammar_type = None
	else:
		new_grammar_type = WordGrammarType.objects.get(id = int(old_word[4]))
	new_concept.grammar_type = new_grammar_type
	new_concept.save()
	# End of creation of concept
	# Now add new english word as a term. It shouldn't be in database, but check it first
	word_exists = True
	try:
		word_check = Word.objects.get(word = old_word[1].strip())
	except:
		word_exists = False
	if(word_exists == False):
		new_word = Word(word = old_word[1].strip(), language = english)
		new_word.save()
	elif(word_exists == True):
		# get new_word object as existing one, so if it's already exists, it can be binded to concept
		new_word = Word.objects.get(word = old_word[1].strip())	
	new_binding = Binding(word = new_word, concept = new_concept)
	new_binding.save()
	# as english one doesn't have entities, we give it none. FIXME - maybe we should give something anyway?
	# Now we get list of binded terms in Latvian
	# check if there is list of bindings. There could be "lonely wolfes" out there
	values = (int(old_word[0]),)
	db_connection_cursor.execute('select * from terms_bindings where first_term_id=%s', values)
	old_bindings = db_connection_cursor.fetchall()
	words_added = []
	if old_bindings != None:
		for old_binding in old_bindings:
			# Get values for binded latvian word
			for translation in translations:
				if(old_binding[2] == translation[0]):
					new_translation = translation
					break
			translation = new_translation
			# Check if there is no such latvian word already in db
			word_exists = True
			try:
				word_check = Word.objects.get(word = translation[1].strip())
			except:
				word_exists = False
			if(word_exists == False):
				# Add it
				# new_word_date = time.strftime('%Y-%m-%d %H:%M:%S',time.gmtime(float(old_word[12])))
				new_word = Word(word = translation[1].strip(), language = latvian)
				new_word.save()
			elif(word_exists == True):
				# get new_word object as existing one, so if it's already exists, it can be binded to concept
				new_word = Word.objects.get(word = translation[1].strip())
			# Check if there is no already such word binded
			already_added = False
			for w in words_added:
				if(w == new_word):
					already_added = True
					break
			if(already_added == False):
				# Bind new_word to concept
				# Binding sources can be many, so entries can be dublicated
				# get dublicates from old db
				values = (old_word[0], translation[0])
				db_connection_cursor.execute('select * from terms_bindings where first_term_id=%s and second_term_id=%s', values)
				old_binding_sources = db_connection_cursor.fetchall()
				# create binding
				new_binding = Binding(word = new_word, concept = new_concept)
				new_binding.save()
				for old_binding_source in old_binding_sources:
					# get a old record and add it to new_binding_entities
					new_binding.entities.add(Entity.objects.get(id=old_binding_source[3]))
				new_binding.save()
				# Add to already added bindings so it won't create dublicates
				words_added.append(new_word)
	else:
		# otherwise skip bindings for this concept/english word and add tag "lonelywolf"
		new_concept.tags.add(lonelywolf_tag)
		new_concept.save()

	# 6.3 Comments for word
	for old_comment in old_comments:
		# if it's a comment for this word
		if(old_comment[3] == old_word[0]):
			# if there is no user id, then ignore comment
			if(old_comment[2] != None and old_comment[2] != 0):
				# new_comment_date = time.strftime('%Y-%m-%d %H:%M:%S',time.gmtime(float(old_comment[1])))
				# find user
				for old_user in old_users:
					if(old_user[0] == old_comment[2]):
						comment_user = old_user[1]
						break
				new_comment = Comment(comment_subject=None, comment=old_comment[6], concept = new_concept, user=User.objects.get(username=comment_user))
				new_comment.save()

db_connection.close()
