# -*- coding: utf-8 -*-
import django.forms as forms
from django.core.exceptions import *
from wordy.database.models import *
from sets import Set

class ConceptLanguageData:
    def __init__(self):
        self.language = None
        self.description = None
        self.bindings = []

class ConceptDataByLanguage:
    def __init__(self):
        self.concept = None
        self.data = []


def prepareDataForExport():
    #fetch essentialy the whole database
    concepts = Concept.objects.select_related('bindings','bindings__word','bindings__word__language', 'descriptions')
    result = []

    #prepare set for each language
    for concept in concepts:
        langs = {}

        for binding in concept.bindings.all():
            language = binding.word.language
            if not language in langs:
                data = ConceptLanguageData()
                data.language = language
                langs[data.language] = data
            else:
                data = langs[language]
            data.bindings.append(binding)

        for description in concept.descriptions.all():
            language = description.language
            if not language in langs:
                data = ConceptLanguageData()
                data.language = language
                langs[data.language] = data
            else:
                data = langs[language]
            data.description = description

        entry = ConceptDataByLanguage()
        entry.concept = concept
        entry.data = langs.values()
        result.append(entry)

    return result


