# -*- coding: utf-8 -*-
from wordy.database.models import *

class TagFilter:
    TAGFILTER_VAR_INC = "filterTagsIncl"
    TAGFILTER_VAR_EX = "filterTagsExcl"

    def __init__(self, request = None):
        self.tagsInc = []
        self.tagsEx = []

        if (request and (TagFilter.TAGFILTER_VAR_INC in request.session)) :
           self.tagsInc = request.session[TagFilter.TAGFILTER_VAR_INC]

        if (request and (TagFilter.TAGFILTER_VAR_EX in request.session)) :
           self.tagsEx = request.session[TagFilter.TAGFILTER_VAR_EX]


    def save(self, request) :
        request.session[TagFilter.TAGFILTER_VAR_INC] = self.tagsInc
        request.session[TagFilter.TAGFILTER_VAR_EX] = self.tagsEx

    def clearFilter(self):
        #removes all tags from filter
		self.tagsInc=[]
		self.tagsEx=[]

    def addFilterInc(self, tag):
        #tag is an Tag object from DB model
        if not (tag in self.tagsInc):
            self.tagsInc.append(tag)
        if tag in self.tagsEx:
            self.tagsEx.remove(tag)

    def addFilterEx(self, tag):
        #tag is an Tag object from DB model
        if not (tag in self.tagsEx):
            self.tagsEx.append(tag)
        if tag in self.tagsInc:
            self.tagsInc.remove(tag)

    def removeFilter(self, tag):
        #tag is an Tag object from DB model
        if tag in self.tagsEx:
            self.tagsEx.remove(tag)
        if tag in self.tagsInc:
            self.tagsInc.remove(tag)

    def filterWordList(self, wordList):
        #the wordList is an django collection
        result = wordList

        for tagToFilter in self.tagsInc:
             result = result.filter(binding__concept__tags = tagToFilter)
        for tagToFilter in self.tagsEx:
            result = result.exclude(binding__concept__tags = tagToFilter)

        return result;

    def filterConceptList(self, list):
        #the wordList is an django collection
        result = list

        for tagToFilter in self.tagsInc:
             result = result.filter(tags = tagToFilter)
        for tagToFilter in self.tagsEx:
            result = result.exclude(tags = tagToFilter)

        return result;
