# -*- coding: utf-8 -*-
from django.conf.urls.defaults import *
import views

urlpatterns = patterns('',
    # Example:
    # (r'^wordy/', include('wordy.foo.urls')),

    # Uncomment the admin/doc line below and add 'django.contrib.admindocs'
    # to INSTALLED_APPS to enable admin documentation:
    # (r'^admin/doc/', include('django.contrib.admindocs.urls')),

    url(r'^$', views.main, name = 'main'),
    url(r'^about$', views.about, name = 'about'),
    url(r'^systeminfo$', views.systeminfo, name = 'systeminfo'),
    url(r'^login$', views.login, name = 'loginAction'),
    url(r'^register$', views.register, name = 'register'),
    url(r'^logout$', views.logout, name = 'logoutAction'),
    url(r'^user$', views.user, name = 'userPage'),
    url(r'^user/reviewConcepts/(?P<offset>\d+)$', views.user_concepts_review, name = 'user_concepts_review'),

    url(r'^opensearchdescription.xml$', views.opensearchdescription, name = 'opensearchdescription'),
    url(r'^opensearch$', views.opensearch, name = 'opensearch'),

    url(r'^tbxexport.xml$', views.tbxExport, name = 'tbxexport'),

    url(r'^search/(?P<offset>\d+)$', views.search, name = 'search'),
    url(r'^switchSearchResultsType$', views.switchSearchResultsType, name = 'switchSearchResultsType'),

    url(r'^addBindingSearch$', views.addBindingSearch, name = 'addBindingSearch'),
    url(r'^words$', views.wordList0, name = 'wordList'),
    url(r'^words/(?P<offset>\d+)$', views.wordList, name = 'wordListPage'),
    url(r'^words/action$', views.wordListAction, name = 'wordListAction'),
    url(r'^word/add$', views.wordAdd, name='wordAdd'),
    url(r'^word/(?P<word_id>\d+)$', views.wordDetails, name='wordDetails'),
    url(r'^word/(?P<word_id>\d+)/delete$', views.wordDelete, name='wordDelete'),
    url(r'^word/(?P<word_id>\d+)/review$', views.wordReview, name='wordReview'),
    url(r'^word/(?P<word_id>\d+)/to_(?P<language_id>\d+)$', views.wordTranslations, name='wordTranslations'),

    #url(r'^concepts$', views.conceptList),
    url(r'^concepts/new$', views.conceptNew, name = 'conceptNew'),
    url(r'^concepts/bulkadd$', views.conceptBulkAdd, name = 'conceptBulkAdd'),
    url(r'^concepts/action$', views.conceptListAction, name = 'conceptListAction'),
    url(r'^concepts/(?P<concept_id>\d+)$', views.conceptDetails, name='conceptDetails'),
    url(r'^concepts/removeTag$', views.conceptTagRemove, name='conceptTagRemove'),
    url(r'^concepts/addTag$', views.conceptTagAdd, name='conceptTagAdd'),
    url(r'^concepts/(?P<concept_id>\d+)/review$', views.conceptReview, name='conceptReview'),
    url(r'^concepts/(?P<concept_id>\d+)/delete$', views.conceptDelete, name='conceptDelete'),
    url(r'^concepts/(?P<concept_id>\d+)/addComment$', views.conceptAddComment, name='conceptAddComment'),
    url(r'^concepts/(?P<concept_id>\d+)/addBinding$', views.conceptAddBinding, name='conceptAddBinding'),
    url(r'^concepts/(?P<concept_id>\d+)/grammarTypeSet$', views.conceptGrammarTypeSet, name='conceptGrammarTypeSet'),
    url(r'^concepts/(?P<concept_id>\d+)/setSunscribtion$', views.conceptSetSubscribtion, name='conceptSetSubscribtion'),

    url(r'^binding/setUses$', views.bindingSetUses, name='bindingSetUses'),

    url(r'^tags$', views.tagList, name='tagList'),
    url(r'^tags/action$', views.tagListAction, name='tagListAction'),
    url(r'^tags/(?P<tag_id>\d+)/delete$', views.tagDelete, name='tagDelete'),
    url(r'^tag/add$', views.tagAdd, name='tagAdd'),
    url(r'^tagLookup$', views.tagLookup, name='tagLookup'),
    url(r'^tag/(?P<tag_id>\d+)/(?P<offset>\d+)$', views.tagDetails, name='tagDetails'),

    url(r'^tagFilter/add$', views.tagFilterAdd, name='tagFilterAdd'),
    url(r'^tagFilter/remove/(?P<tag_id>\d+)$', views.tagFilterRemove, name='tagFilterRemove'),

    url(r'^description/(?P<description_id>\d+)/delete$', views.descriptionDelete, name='descriptionDelete'),
    url(r'^description/(?P<description_id>\d+)/edit$', views.descriptionEdit, name='descriptionEdit'),
    url(r'^concepts/(?P<concept_id>\d+)/addDescription$', views.descriptionAdd, name='descriptionAdd'),    

    url(r'^binding/(?P<binding_id>\d+)/delete$', views.bindingDelete, name='bindingDelete'),

)
